
% call irf
% calculating impulse response function

%%% commitment
[M_com_w,C_com_w,M_com_a,C_com_a,~,~,~] = ComAlgR(A,B,Q,R,U,betta,n1,n2,cutoff,C,theta_evil);

x1p2      = Var1SimPs(M_com_w,C*upi,Tbig);              %worst case
x2up1     = x1p2*C_com_w';
Simupi_Cw = x2up1(:,1:3);           %pi(t),y(t),i(t)  

x1p2a      = Var1SimPs(M_com_a,C*upi,Tbig);              %worst case
x2up1a     = x1p2a*C_com_a';
Simupi_Ca = x2up1a(:,1:3);           %pi(t),y(t),i(t)  

% robust solution under discretion
[M_disc_w,C_disc_w,M_disc_a,C_disc_a,Fu,Fu_a,~,~] = DiscAlgR(A,B,Q,R,U,betta,n1,n2,eye(n1),zeros(n2,n1),...
                                               1e-6,0,1,0,1,0,1e+4,C,theta_evil);

x1_it        = Var1SimPs(M_disc_w,C1*upi,Tbig);         %worst case
x2_it        = x1_it*C_disc_w';
interest_it  = -x1_it*Fu';
Simupi_Dw = [x2_it,interest_it];                      %IRF of y(t),pi(t),i(t) to price shock  

x1a_it        = Var1SimPs(M_disc_a,C1*upi,Tbig);         %worst case
x2a_it        = x1a_it*C_disc_a';
interest_ait  = -x1a_it*Fu_a';
Simupi_Da = [x2a_it,interest_ait];                      %IRF of y(t),pi(t),i(t) to price shock                                           
                                           
% -------------- speed limit targeting                                           
% weight in delegated loss function
n_slp = 2;
[Q_s,U_s,R_s] = cal_slp(n_slp,n,Cu,lambda_x);

%robust solution under speed limit policy
[M_dw_sp,C_dw_sp,M_da_sp,C_da_sp,Fu_sp,Fu_asp,~,~] = DiscAlgR(A,B,Q_s,R_s,U_s,betta,n1,n2,eye(n1),zeros(n2,n1),...
                                               1e-6,0,1,0,1,0,1e+4,C,theta_evil);
                                           
x1_sl        = Var1SimPs(M_dw_sp,C1*upi,Tbig);         %worst case
x2_sl        = x1_sl*C_dw_sp';
interest_sl  = -x1_sl*Fu_sp';
Simupi_Dw_sp = [x2_sl,interest_sl];   

x1a_sl        = Var1SimPs(M_da_sp,C1*upi,Tbig);         %approximating case
x2a_sl        = x1_sl*C_da_sp';
interest_asl  = -x1a_sl*Fu_asp';
Simupi_Da_sp = [x2a_sl,interest_asl];   

% --------------- nominal income growth
n_nit = 2;
[Q_n,U_n,R_n] = cal_nit(n_nit,n,Cu,lambda_x);

%robust solution under speed limit policy
[M_dw_nt,C_dw_nt,M_da_nt,C_da_nt,Fu_nt,Fu_ant,~,~] = DiscAlgR(A,B,Q_n,R_n,U_n,betta,n1,n2,eye(n1),zeros(n2,n1),...
                                               1e-6,0,1,0,1,0,1e+4,C,theta_evil);
x1_nt        = Var1SimPs(M_dw_nt,C1*upi,Tbig);         %worst case
x2_nt        = x1_nt*C_dw_nt';
interest_nt  = -x1_nt*Fu_nt';
Simupi_Dw_nt = [x2_nt,interest_nt];   

x1a_nt        = Var1SimPs(M_da_nt,C1*upi,Tbig);         %approximating case
x2a_nt        = x1a_nt*C_da_nt';
interest_ant  = -x1a_nt*Fu_ant';
Simupi_Da_nt = [x2a_nt,interest_ant];  

%%% plot impulse response function
tline = 1:Tbig;

figure(1)
plot(tline',Simupi_Cw(:,1),'k-',tline',Simupi_Dw(:,1),'b--', tline',Simupi_Dw_nt(:,1),'r-.',tline',Simupi_Dw_sp(:,1),'m-o');
ylabel('Response of output gap'); xlabel('Quarters');
legend('Commitment','Pure discretion','Nominal income growth','Speed limit policy','location','best');
saveas(gcf,'figure1','epsc')

figure(2)
plot(tline',Simupi_Cw(:,2),'k-',tline',Simupi_Dw(:,2),'b--',tline',Simupi_Dw_nt(:,2),'r-.',tline',Simupi_Dw_sp(:,2),'m-o');
ylabel('Response of inflation'); xlabel('Quarters');
legend('Commitment','Pure discretion','Nominal income growth','Speed limit policy ','location','best');
saveas(gcf,'figure2','epsc')

figure(3)
plot(tline',Simupi_Cw(:,1),'k-',tline',Simupi_Ca(:,1),'k-x',tline',Simupi_Dw(:,1),'b--',tline',Simupi_Da(:,1),'b-d',...
    tline',Simupi_Dw_nt(:,1),'r-.',tline',Simupi_Da_nt(:,1),'r-*' ,tline',Simupi_Dw_sp(:,1),'m-o',tline',Simupi_Da_sp(:,1),'m:');
ylabel('Response of output gap'); xlabel('Quarters');
legend('Precommitment (worst)','Precommitment (approx)','Pure discretion (worst)','Pure discretion (approx)'...
    ,'Nominal income growth (worst)','Nominal income growth (approx)','Speed limit policy (worst)','Speed limit policy (approx)');

figure(4)
plot(tline',Simupi_Cw(:,2),'k-',tline',Simupi_Ca(:,2),'k-x',tline',Simupi_Dw(:,2),'b--',tline',Simupi_Da(:,2),'b-d',...
    tline',Simupi_Dw_nt(:,2),'r-.',tline',Simupi_Da_nt(:,2),'r-*',tline',Simupi_Dw_sp(:,2),'m-o',tline',Simupi_Da_sp(:,2),'m:');
ylabel('Response of inflation'); xlabel('Quarters');
legend('Precommitment (worst)','Precommitment (approx)','Pure discretion (worst)','Pure discretion (approx)'...
    ,'Nominal income growth (worst)','Nominal income growth (approx)','Speed limit policy (worst)','Speed limit policy (approx)');

price_level;

% nominal exchange rate = price level
% terms of trade
tot_cw = sigma_nu*Simupi_Cw(:,1); tot_ca = sigma_nu*Simupi_Ca(:,1); % commitment
tot_dw = sigma_nu*Simupi_Dw(:,1); tot_da = sigma_nu*Simupi_Da(:,1); % discretion
tot_sw = sigma_nu*Simupi_Dw_sp(:,1); tot_sa = sigma_nu*Simupi_Da_sp(:,1); % speed limit
tot_nw = sigma_nu*Simupi_Dw_nt(:,1); tot_na = sigma_nu*Simupi_Da_nt(:,1); % nominal income growth

% nominal exchange rate
% e(t) = p(t) + nu*s(t), given p*(t) 
nex_cw = p_com_w + nu*tot_cw; nex_ca = p_com_a + nu*tot_ca;
nex_dw = p_disc_w + nu*tot_dw; nex_da = p_disc_a + nu*tot_da;
nex_sw = p_slp_w + nu*tot_sw; nex_sa = p_slp_a + nu*tot_sa;
nex_nw = p_nit_w + nu*tot_nw; nex_na = p_nit_a + nu*tot_na;

figure(7)
plot(tline',nex_cw,'k-',tline',nex_dw,'b--',tline',nex_nw,'r-.',tline',nex_sw,'m-o');
ylabel('Response of nominal exchange rate'); xlabel('Quarters');
legend('Commitment','Pure discretion','Nominal income growth','Speed limit policy','location','best'); 
saveas(gcf,'figure3','epsc')

figure(8)
plot(tline',nex_cw,'k-',tline',nex_ca,'k-x',tline',nex_dw,'b--',tline',nex_da,'b-d',...
    tline',nex_nw,'r-.',tline',nex_na,'r-*',tline',nex_sw,'m-o',tline',nex_sa,'m:');
ylabel('Response of nominal exchange rate'); xlabel('Quarters');
legend('Precommitment (worst)','Precommitment (approx)','Pure discretion (worst)','Pure discretion (approx)'...
    ,'Nominal income growth (worst)','Nominal income growth (approx)','Speed limit policy (worst)','Speed limit policy (approx)');          

