% call_policy_implement

% This codes provides the calculation of welfare losses under each policy
% regimes

% solving REE under each regimes

% ------------------------------ commitment
[~,~,~,~,var_com]  = calc_com(n,n1,n2,n3,A,B,Q,R,U,betta,cutoff,C,theta_evil,Cx,Cu,Z,SigmaXX);
% fprintf('\n')
disp('*** Welfare losses under commitment ***')
disp('Worst case    Approximating case')
disp(var_com); fprintf('\n')

%------------------------------- discretionary regimes
%%% pure discretion
[~,~,~,~,var_disc] = calc_disc(n,n1,n2,n3,A,B,Q,R,U,betta,C,theta_evil,Cx,Cu,Z,SigmaXX);
% 
disp('*** Welfare losses under pure discretion ***')
disp('Worst case    Approximating case')
disp(var_disc); fprintf('\n')

%%% optimized regimes under discretion
lam_vec = 0.01:0.01:0.99;

% inflation targeting
n_it = 2; % # of target variables in the loss function
lossd_it = delegate_it(n,n1,n2,n3,A,B,betta,C,theta_evil,Cx,Cu,Z,SigmaXX,lam_vec,n_it);
disp('*** Welfare losses under inflation targeting ***')
disp('Worst case    Approximating case')
disp(lossd_it); fprintf('\n')

% speed limit targeting
n_slp = 2; % # of target variables in the loss function
lossd_slp = delegate_slp(n,n1,n2,n3,A,B,betta,C,theta_evil,Cx,Cu,Z,SigmaXX,lam_vec,n_slp);
disp('*** Welfare losses under speed limit policy ***')
disp('Worst case    Approximating case')
disp(lossd_slp); fprintf('\n')


% nominal income growth targeting
n_nit = 2; % # of target variables in the loss function
lossd_nit = delegate_nit(n,n1,n2,n3,A,B,betta,C,theta_evil,Cx,Cu,Z,SigmaXX,lam_vec,n_nit);
disp('*** Welfare losses under nominal income growth targeting ***')
disp('Worst case    Approximating case')
disp(lossd_nit); fprintf('\n')

% real exchange rate targeting
n_rex = 2;
lossd_rex = delegate_rex(n,n1,n2,n3,A,B,betta,C,theta_evil,Cx,Cu,Z,SigmaXX,lam_vec,n_rex,nu,sigma_nu);
disp('*** Welfare losses under real exchange rate targeting ***')
disp('Worst case    Approximating case')
disp(lossd_rex); fprintf('\n')