% nominal income growth targeting

function lossd_nit = delegate_nit(n,n1,n2,n3,A,B,betta,C,theta_evil,Cx,Cu,Z,SigmaXX,lam_vec,n_nit)

     num_lam = size(lam_vec,2);

     loss_nit_rob_w = zeros(num_lam,1); loss_nit_rob_a = zeros(num_lam,1);

for ii = 1:num_lam
    lam_star = lam_vec(ii);
    
   % weight in delegated loss function
    Cxx = zeros(n_nit,n);
    Cxx(1,3) = -1; Cxx(1,4) = 1; Cxx(1,5) = 1; % stabilization of nominal income growth
    Cxx(2,5) = 1;
    
    Z_s = diag([lam_star 1]);
    Q = Cxx'*Z_s*Cxx;
    U = Cxx'*Z_s*Cu;
    R = Cu'*Z_s*Cu;
   
    
   %robust solution
   [M_disc_w,C_disc_w,M_disc_a,C_disc_a,Fu,~,~,~] = DiscAlgR(A,B,Q,R,U,betta,n1,n2,eye(n1),zeros(n2,n1),...
                                               1e-6,0,1,0,1,0,1e+4,C,theta_evil);
   % second moment for worst case
   [~, ~, Lossd_r] = calc_welf_disc(n,n1,n2,n3,M_disc_w,C_disc_w,Fu,Cx,Cu,Z,SigmaXX);
   loss_nit_rob_w(ii) = Lossd_r;
  
   % second moment for approximating case
   [~, ~, Lossd_a] = calc_welf_disc(n,n1,n2,n3,M_disc_a,C_disc_a,Fu,Cx,Cu,Z,SigmaXX);
   loss_nit_rob_a(ii) = Lossd_a;
        
end

    lossd_nit_w = min(loss_nit_rob_w); lossd_nit_a = min(loss_nit_rob_a);

    lossd_nit = [lossd_nit_w lossd_nit_a];




