% real exchange rate targeting

function lossd_rex = delegate_rex(n,n1,n2,n3,A,B,betta,C,theta_evil,Cx,Cu,Z,SigmaXX,lam_vec,n_rex,nu,sigma_nu)

     num_lam = size(lam_vec,2);

     loss_rex_rob_w = zeros(num_lam,1); loss_rex_rob_a = zeros(num_lam,1);

for ii = 1:num_lam
    lam_star = lam_vec(ii);
    
   % weight in delegated loss function
    % weight in delegated loss function
    Cxx = zeros(n_rex,n);
    Cxx(1,3) = -(1-nu)*sigma_nu; Cxx(1,4) = (1-nu)*sigma_nu; % stabilization of real exchange rate change
    Cxx(2,5) = 1;
    
    Z_s = diag([lam_star 1]);
    Q = Cxx'*Z_s*Cxx;
    U = Cxx'*Z_s*Cu;
    R = Cu'*Z_s*Cu;
   
   %robust solution
   [M_disc_w,C_disc_w,M_disc_a,C_disc_a,Fu,~,~,~] = DiscAlgR(A,B,Q,R,U,betta,n1,n2,eye(n1),zeros(n2,n1),...
                                               1e-6,0,1,0,1,0,1e+4,C,theta_evil);
   % second moment for worst case equilibrium
   [~, ~, Lossd_r] = calc_welf_disc(n,n1,n2,n3,M_disc_w,C_disc_w,Fu,Cx,Cu,Z,SigmaXX);
   loss_rex_rob_w(ii) = Lossd_r;
  
   % second moment for approximating equilibrium
   [~, ~, Lossd_a] = calc_welf_disc(n,n1,n2,n3,M_disc_a,C_disc_a,Fu,Cx,Cu,Z,SigmaXX);
   loss_rex_rob_a(ii) = Lossd_a;
        
end

    lossd_rex_w = min(loss_rex_rob_w); lossd_rex_a = min(loss_rex_rob_a);

    lossd_rex = [lossd_rex_w lossd_rex_a];