
% calc_welf_disc
% This code provides the unconditional welfare loss
% This code is based on Soderstrom's matlab routine

function [SigmaYd, varsYd, Lossd] = calc_welf_disc(n,n1,n2,nuu,Md,Cd,Fd,Cx,Cu,Z,Sigmae)

  % Calculate unconditional variances
      vvd = (eye(n1*n1) - kron(Md,Md)) \ Sigmae(:);
      Sigmax1d = reshape(vvd,n1,n1);
      Sigmax2d = Cd*Sigmax1d*Cd';
      varsd = [ Sigmax2d(1,1) Sigmax2d(2,2) ];


  % Rewrite solution as [ x1(t+1)' x2(t+1)' u(t+1) ] = MM [ x1(t)' x2(t)' u(t)' ] + LL e(t+1)    
      MM0 = [ eye(n1) zeros(n1,n2+nuu);
              -Cd eye(n2) zeros(n2,nuu);
              -Fd zeros(nuu,n2) eye(nuu) ];
      MM1 = zeros(n+nuu);
         MM1(1:n1,1:n1) = Md;
      LL1 = [ eye(n1); zeros(n2+nuu,n1) ];
      MM = MM0\MM1;
      LL = MM0\LL1;
      
      Sigmae1 = LL*Sigmae*LL';
      vv = (eye((n+nuu)*(n+nuu)) - kron(MM,MM)) \ Sigmae1(:);
      Sigmaxud = reshape(vv,n+nuu,n+nuu);
      

   % Calculate unconditional variances of target variables
      SigmaYd = [ Cx Cu ]*Sigmaxud*[ Cx Cu ]';
      varsYd = diag(SigmaYd)';
      Lossd = trace(Z*SigmaYd);
      
end