function J0 = SimpAlgRLoss( par,A,B,Q,R,U,bet,n1,n2,Fu,cutoff,C,theta );
%SimpAlgRLoss    Loss function of evil agent in case with simple rule. Used
%                in SimpAlgROpt
%
%
%  Usage:    J0 = SimpAlgRLoss( par );
%
%            see SimpAlgROpt
%
%
%
%
%  Calls on:  SimpAlgR
%
%
%
%  Paolo Giordani and Paul.Soderlind@unisg.ch, Jun 2001
%------------------------------------------------------------------------------


FvX = [ reshape(par,n1,n1), zeros(n1,n2) ];   %n1^2 vector -> n1xn matrix

[M,N,Ma,Na,J0,J0a] = SimpAlgR(A,B,Q,R,U,bet,n1,n2,Fu,zeros(n1,1),cutoff,C,theta,FvX,0);

if exist('OCTAVE_VERSION');
  J0 = J0;     %Octave are for maximizing, evil agent wants to maximize loss
else;
  J0 = -J0;    %MatLab optimization routines are for minimizing, evil agent wants to minimize gain
end;
%------------------------------------------------------------------------------

